<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: flair::core::Quaternion Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classflair_1_1core_1_1_quaternion.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="classflair_1_1core_1_1_quaternion-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">flair::core::Quaternion Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Class defining a quaternion.  
 <a href="classflair_1_1core_1_1_quaternion.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_quaternion_8h_source.html">Quaternion.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a35151d7d2158d0a4714a66d2d426cf9c"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#a35151d7d2158d0a4714a66d2d426cf9c">Quaternion</a> (float <a class="el" href="classflair_1_1core_1_1_quaternion.html#a5394aa98e53d17253efd3c5eaca11fb2">q0</a>=1, float <a class="el" href="classflair_1_1core_1_1_quaternion.html#aaaea36fb6b8a1ae444f879e509cb4db5">q1</a>=0, float <a class="el" href="classflair_1_1core_1_1_quaternion.html#a47c497424771521c976143ef07bc7da1">q2</a>=0, float <a class="el" href="classflair_1_1core_1_1_quaternion.html#aabf0e55b55e7c66716494c5d7f343e70">q3</a>=0)</td></tr>
<tr class="memdesc:a35151d7d2158d0a4714a66d2d426cf9c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a35151d7d2158d0a4714a66d2d426cf9c">More...</a><br /></td></tr>
<tr class="separator:a35151d7d2158d0a4714a66d2d426cf9c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7aa88aa352e17590e0f9b454357fdbfc"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#a7aa88aa352e17590e0f9b454357fdbfc">~Quaternion</a> ()</td></tr>
<tr class="memdesc:a7aa88aa352e17590e0f9b454357fdbfc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#a7aa88aa352e17590e0f9b454357fdbfc">More...</a><br /></td></tr>
<tr class="separator:a7aa88aa352e17590e0f9b454357fdbfc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6931ec913f61c9708ef5970e63f8b0b5"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#a6931ec913f61c9708ef5970e63f8b0b5">GetNorm</a> (void) const </td></tr>
<tr class="memdesc:a6931ec913f61c9708ef5970e63f8b0b5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Norm.  <a href="#a6931ec913f61c9708ef5970e63f8b0b5">More...</a><br /></td></tr>
<tr class="separator:a6931ec913f61c9708ef5970e63f8b0b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa540ffe227bbacd124c77f95d8c720b3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#aa540ffe227bbacd124c77f95d8c720b3">Normalize</a> (void)</td></tr>
<tr class="memdesc:aa540ffe227bbacd124c77f95d8c720b3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Normalize.  <a href="#aa540ffe227bbacd124c77f95d8c720b3">More...</a><br /></td></tr>
<tr class="separator:aa540ffe227bbacd124c77f95d8c720b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4753cafd0c78d78a6e6d0200a4cc596f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#a4753cafd0c78d78a6e6d0200a4cc596f">GetLogarithm</a> (<a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3Df</a> &amp;logarithm)</td></tr>
<tr class="memdesc:a4753cafd0c78d78a6e6d0200a4cc596f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Logarithm.  <a href="#a4753cafd0c78d78a6e6d0200a4cc596f">More...</a><br /></td></tr>
<tr class="separator:a4753cafd0c78d78a6e6d0200a4cc596f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abbda897244c722294de3812bfe7a595b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3Df</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#abbda897244c722294de3812bfe7a595b">GetLogarithm</a> (void)</td></tr>
<tr class="memdesc:abbda897244c722294de3812bfe7a595b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Logarithm.  <a href="#abbda897244c722294de3812bfe7a595b">More...</a><br /></td></tr>
<tr class="separator:abbda897244c722294de3812bfe7a595b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae3cf1c1892b4d1c70ca055e42709f9df"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#ae3cf1c1892b4d1c70ca055e42709f9df">Conjugate</a> (void)</td></tr>
<tr class="memdesc:ae3cf1c1892b4d1c70ca055e42709f9df"><td class="mdescLeft">&#160;</td><td class="mdescRight">Conjugate.  <a href="#ae3cf1c1892b4d1c70ca055e42709f9df">More...</a><br /></td></tr>
<tr class="separator:ae3cf1c1892b4d1c70ca055e42709f9df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab7b4f5b1f7419f6179f4fccc49e4e173"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classflair_1_1core_1_1_quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#ab7b4f5b1f7419f6179f4fccc49e4e173">GetConjugate</a> (void)</td></tr>
<tr class="memdesc:ab7b4f5b1f7419f6179f4fccc49e4e173"><td class="mdescLeft">&#160;</td><td class="mdescRight">Conjugate.  <a href="#ab7b4f5b1f7419f6179f4fccc49e4e173">More...</a><br /></td></tr>
<tr class="separator:ab7b4f5b1f7419f6179f4fccc49e4e173"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a08b196fb32f87dd62e6a3906e5ecaf2c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classflair_1_1core_1_1_quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#a08b196fb32f87dd62e6a3906e5ecaf2c">GetDerivative</a> (const <a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3Df</a> &amp;angularSpeed) const </td></tr>
<tr class="memdesc:a08b196fb32f87dd62e6a3906e5ecaf2c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Derivative.  <a href="#a08b196fb32f87dd62e6a3906e5ecaf2c">More...</a><br /></td></tr>
<tr class="separator:a08b196fb32f87dd62e6a3906e5ecaf2c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9be083f02e545535ba9dde0dd2ecbcb7"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#a9be083f02e545535ba9dde0dd2ecbcb7">Derivate</a> (const <a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3Df</a> &amp;angularSpeed)</td></tr>
<tr class="memdesc:a9be083f02e545535ba9dde0dd2ecbcb7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Derivate.  <a href="#a9be083f02e545535ba9dde0dd2ecbcb7">More...</a><br /></td></tr>
<tr class="separator:a9be083f02e545535ba9dde0dd2ecbcb7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d45a89dbbb73633701e344259e8b003"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#a5d45a89dbbb73633701e344259e8b003">ToEuler</a> (<a class="el" href="classflair_1_1core_1_1_euler.html">Euler</a> &amp;euler) const </td></tr>
<tr class="memdesc:a5d45a89dbbb73633701e344259e8b003"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert to euler angles.  <a href="#a5d45a89dbbb73633701e344259e8b003">More...</a><br /></td></tr>
<tr class="separator:a5d45a89dbbb73633701e344259e8b003"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad98cdabf355956519d718aac330174ef"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classflair_1_1core_1_1_euler.html">Euler</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#ad98cdabf355956519d718aac330174ef">ToEuler</a> (void) const </td></tr>
<tr class="memdesc:ad98cdabf355956519d718aac330174ef"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert to euler angles.  <a href="#ad98cdabf355956519d718aac330174ef">More...</a><br /></td></tr>
<tr class="separator:ad98cdabf355956519d718aac330174ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a29d40f4afe4fa2f79a08a09619a4fc1a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#a29d40f4afe4fa2f79a08a09619a4fc1a">ToRotationMatrix</a> (<a class="el" href="classflair_1_1core_1_1_rotation_matrix.html">RotationMatrix</a> &amp;matrix) const </td></tr>
<tr class="memdesc:a29d40f4afe4fa2f79a08a09619a4fc1a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert to rotation matrix.  <a href="#a29d40f4afe4fa2f79a08a09619a4fc1a">More...</a><br /></td></tr>
<tr class="separator:a29d40f4afe4fa2f79a08a09619a4fc1a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4f3a6012a315db41398417d0b93704ec"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4f3a6012a315db41398417d0b93704ec"></a>
<a class="el" href="classflair_1_1core_1_1_quaternion.html">Quaternion</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator+=</b> (const <a class="el" href="classflair_1_1core_1_1_quaternion.html">Quaternion</a> &amp;quaternion)</td></tr>
<tr class="separator:a4f3a6012a315db41398417d0b93704ec"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec35455d090ebfdf8323b5019f9923bd"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aec35455d090ebfdf8323b5019f9923bd"></a>
<a class="el" href="classflair_1_1core_1_1_quaternion.html">Quaternion</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator-=</b> (const <a class="el" href="classflair_1_1core_1_1_quaternion.html">Quaternion</a> &amp;quaternion)</td></tr>
<tr class="separator:aec35455d090ebfdf8323b5019f9923bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a48f3e9b60017cbc8d7e9af035f85f3bf"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a48f3e9b60017cbc8d7e9af035f85f3bf"></a>
<a class="el" href="classflair_1_1core_1_1_quaternion.html">Quaternion</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (const <a class="el" href="classflair_1_1core_1_1_quaternion.html">Quaternion</a> &amp;quaternion)</td></tr>
<tr class="separator:a48f3e9b60017cbc8d7e9af035f85f3bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a5394aa98e53d17253efd3c5eaca11fb2"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#a5394aa98e53d17253efd3c5eaca11fb2">q0</a></td></tr>
<tr class="memdesc:a5394aa98e53d17253efd3c5eaca11fb2"><td class="mdescLeft">&#160;</td><td class="mdescRight">q0  <a href="#a5394aa98e53d17253efd3c5eaca11fb2">More...</a><br /></td></tr>
<tr class="separator:a5394aa98e53d17253efd3c5eaca11fb2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaaea36fb6b8a1ae444f879e509cb4db5"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#aaaea36fb6b8a1ae444f879e509cb4db5">q1</a></td></tr>
<tr class="memdesc:aaaea36fb6b8a1ae444f879e509cb4db5"><td class="mdescLeft">&#160;</td><td class="mdescRight">q1  <a href="#aaaea36fb6b8a1ae444f879e509cb4db5">More...</a><br /></td></tr>
<tr class="separator:aaaea36fb6b8a1ae444f879e509cb4db5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a47c497424771521c976143ef07bc7da1"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#a47c497424771521c976143ef07bc7da1">q2</a></td></tr>
<tr class="memdesc:a47c497424771521c976143ef07bc7da1"><td class="mdescLeft">&#160;</td><td class="mdescRight">q2  <a href="#a47c497424771521c976143ef07bc7da1">More...</a><br /></td></tr>
<tr class="separator:a47c497424771521c976143ef07bc7da1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aabf0e55b55e7c66716494c5d7f343e70"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_quaternion.html#aabf0e55b55e7c66716494c5d7f343e70">q3</a></td></tr>
<tr class="memdesc:aabf0e55b55e7c66716494c5d7f343e70"><td class="mdescLeft">&#160;</td><td class="mdescRight">q3  <a href="#aabf0e55b55e7c66716494c5d7f343e70">More...</a><br /></td></tr>
<tr class="separator:aabf0e55b55e7c66716494c5d7f343e70"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Class defining a quaternion. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a35151d7d2158d0a4714a66d2d426cf9c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">flair::core::Quaternion::Quaternion </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>q0</em> = <code>1</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>q1</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>q2</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>q3</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor. </p>
<p>Construct a quaternion using specified values.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">q0,scalar</td><td>part </td></tr>
    <tr><td class="paramname">q1</td><td></td></tr>
    <tr><td class="paramname">q2</td><td></td></tr>
    <tr><td class="paramname">q3</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a7aa88aa352e17590e0f9b454357fdbfc"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">flair::core::Quaternion::~Quaternion </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a6931ec913f61c9708ef5970e63f8b0b5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">float flair::core::Quaternion::GetNorm </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Norm. </p>
<dl class="section return"><dt>Returns</dt><dd>norm </dd></dl>

</div>
</div>
<a class="anchor" id="aa540ffe227bbacd124c77f95d8c720b3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void flair::core::Quaternion::Normalize </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Normalize. </p>

</div>
</div>
<a class="anchor" id="a4753cafd0c78d78a6e6d0200a4cc596f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void flair::core::Quaternion::GetLogarithm </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3Df</a> &amp;&#160;</td>
          <td class="paramname"><em>logarithm</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Logarithm. </p>
<p>This method also Normalize the quaternion.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">logarithm</td><td>output logarithm </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="abbda897244c722294de3812bfe7a595b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3Df</a> flair::core::Quaternion::GetLogarithm </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Logarithm. </p>
<p>This method also Normalize the quaternion.</p>
<dl class="section return"><dt>Returns</dt><dd>output logarithm </dd></dl>

</div>
</div>
<a class="anchor" id="ae3cf1c1892b4d1c70ca055e42709f9df"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void flair::core::Quaternion::Conjugate </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Conjugate. </p>

</div>
</div>
<a class="anchor" id="ab7b4f5b1f7419f6179f4fccc49e4e173"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classflair_1_1core_1_1_quaternion.html">Quaternion</a> flair::core::Quaternion::GetConjugate </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Conjugate. </p>
<dl class="section return"><dt>Returns</dt><dd>Conjugate </dd></dl>

</div>
</div>
<a class="anchor" id="a08b196fb32f87dd62e6a3906e5ecaf2c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classflair_1_1core_1_1_quaternion.html">Quaternion</a> flair::core::Quaternion::GetDerivative </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3Df</a> &amp;&#160;</td>
          <td class="paramname"><em>angularSpeed</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Derivative. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">w</td><td>angular speed</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>derivative </dd></dl>

</div>
</div>
<a class="anchor" id="a9be083f02e545535ba9dde0dd2ecbcb7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void flair::core::Quaternion::Derivate </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3Df</a> &amp;&#160;</td>
          <td class="paramname"><em>angularSpeed</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Derivate. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">w</td><td>rotationonal speed </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a5d45a89dbbb73633701e344259e8b003"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void flair::core::Quaternion::ToEuler </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classflair_1_1core_1_1_euler.html">Euler</a> &amp;&#160;</td>
          <td class="paramname"><em>euler</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convert to euler angles. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">euler</td><td>output euler angles </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ad98cdabf355956519d718aac330174ef"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classflair_1_1core_1_1_euler.html">Euler</a> flair::core::Quaternion::ToEuler </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convert to euler angles. </p>
<dl class="section return"><dt>Returns</dt><dd>euler angles </dd></dl>

</div>
</div>
<a class="anchor" id="a29d40f4afe4fa2f79a08a09619a4fc1a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void flair::core::Quaternion::ToRotationMatrix </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classflair_1_1core_1_1_rotation_matrix.html">RotationMatrix</a> &amp;&#160;</td>
          <td class="paramname"><em>matrix</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convert to rotation matrix. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">m</td><td>output matrix </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="a5394aa98e53d17253efd3c5eaca11fb2"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">float flair::core::Quaternion::q0</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>q0 </p>

</div>
</div>
<a class="anchor" id="aaaea36fb6b8a1ae444f879e509cb4db5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">float flair::core::Quaternion::q1</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>q1 </p>

</div>
</div>
<a class="anchor" id="a47c497424771521c976143ef07bc7da1"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">float flair::core::Quaternion::q2</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>q2 </p>

</div>
</div>
<a class="anchor" id="aabf0e55b55e7c66716494c5d7f343e70"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">float flair::core::Quaternion::q3</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>q3 </p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceflair.html">flair</a></li><li class="navelem"><a class="el" href="namespaceflair_1_1core.html">core</a></li><li class="navelem"><a class="el" href="classflair_1_1core_1_1_quaternion.html">Quaternion</a></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
